Public Class frmMain

    Private mblnFormActivated As Boolean = False
    Private mintNewFocus As Integer
    Private mstrErrorMsg As String

    Private txtNum As TextBox
    Private lblSol As Label

    Private Sub frmMain_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated

        If Not mblnFormActivated Then
            mblnFormActivated = True
            radAdd.PerformClick()
        End If

    End Sub

    Private Sub Operation_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles radAdd.Click, _
            radSubtract.Click, _
            radMultiply.Click, _
            radDivide.Click

        Dim radOperation As RadioButton

        radOperation = DirectCast(sender, RadioButton)

        Select Case radOperation.Name
            Case "radAdd"
                picOp1.Image = picPlus.Image
                picOp2.Image = picPlus.Image
            Case "radSubtract"
                picOp1.Image = picMinus.Image
                picOp2.Image = picMinus.Image
            Case "radMultiply"
                picOp1.Image = picTimes.Image
                picOp2.Image = picTimes.Image
            Case "radDivide"
                picOp1.Image = picDivide.Image
                picOp2.Image = picTimes.Image
        End Select

        ' Set focus to the first textbox ...
        txtNum0.Focus()

    End Sub


    '******************************************************************************
    '*                       Textbox Event Procedures                             *
    '*                                                                            *
    '*  The three event procedures (GotFocus, KeyPress, and Change) are all       *
    '*  shared among the 6 members of the txtNum control array (indexed 0 to 5).  *
    '*                                                                            *
    '*  The GotFocus event contains the code to highlight the number in the       *
    '*  textbox when the user moves focus to it.                                  *
    '*                                                                            *
    '*  The KeyPress event invokes the programmer-defined ValidKey function       *
    '*  (found the "BAS" module of this project) to ensure only digits are        *
    '*  entered in the field.                                                     *
    '*                                                                            *
    '*  The Change event is coded to implement an "AutoTab" feature. When the     *
    '*  user enters the maximum number of digits for each portion of the          *
    '*  problem, they are automatically positioned on the next enterable control. *
    '*                                                                            *
    '******************************************************************************

    Private Sub txtNum_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles txtNum0.GotFocus, _
            txtNum1.GotFocus, _
            txtNum2.GotFocus, _
            txtNum3.GotFocus, _
            txtNum4.GotFocus, _
            txtNum5.GotFocus

        txtNum = DirectCast(sender, TextBox)
        txtNum.SelectAll()

    End Sub

    Private Sub txtNum_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) _
    Handles txtNum0.KeyPress, _
            txtNum1.KeyPress, _
            txtNum2.KeyPress, _
            txtNum3.KeyPress, _
            txtNum4.KeyPress, _
            txtNum5.KeyPress

        e.Handled = Not (Char.IsDigit(e.KeyChar) Or Asc(e.KeyChar) < 32)

    End Sub

    Private Sub txtNum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles txtNum0.TextChanged, _
            txtNum1.TextChanged, _
            txtNum2.TextChanged, _
            txtNum3.TextChanged, _
            txtNum4.TextChanged, _
            txtNum5.TextChanged

        txtNum = DirectCast(sender, TextBox)

        If txtNum.Text.Length = txtNum.MaxLength Then
            GetNextControl(txtNum, True).Focus()
        End If

    End Sub

    '***************************************************************************
    '                      Command Button Event Procedures                     *
    '***************************************************************************

    Private Sub btnCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalc.Click

        ' This event contains the code to solve the fraction math problem entered
        ' by the user and present the solution to the user. To get here, the user would
        ' have entered the numbers in the "Problem" frame's textboxes and clicked the
        ' "Calculate" button.

        ' The comments will document a sample problem. If the user put in 5 3/8 +
        ' 4 2/3, this routine will do the work to come up with a solution of 10 1/24.


        ' Array of Integers to store the numbers the user has entered in the 
        ' Problem frame textboxes:
        Dim intNum(0 To 5) As Integer

        ' Array of Integers containing the numbers comprising the solution to the problem:
        Dim intSol(0 To 8) As Integer

        Dim intCommDenom As Integer
        Dim intTemp As Integer
        Dim intX As Integer
        Dim intReducer As Integer


        ' First, do some error-checking with the programmer-defined function
        ' DataEntryError, which will return True if there is a problem and
        ' False if not. If there is an error, display the corresponding message,
        ' set focus to the offending textbox, and get out ...

        If DataEntryError() Then
            MsgBox(mstrErrorMsg, vbExclamation, "Fraction Math")
            txtNum = DirectCast(GetControlByName(gbxProblem, "txtNum" & mintNewFocus), TextBox)
            txtNum.Focus()
            Exit Sub
        End If

        ' Load the intNum array to hold the "Problem" numbers from the txtNum textboxes.
        ' Using our sample problem, after the completion of this loop, the contents of
        ' the intNum array will be:
        ' (0) (1) (2) (3) (4) (5)
        ' --- --- --- --- --- ---
        '  5   3   8   4   2   3
        For intX = 0 To 5
            txtNum = DirectCast(GetControlByName(gbxProblem, "txtNum" & intX), TextBox)
            intNum(intX) = Val(txtNum.Text)
        Next

        ' If either the numerator or the denominator of either the first or second
        ' number of the problem is zero, set them both to zero and clear those
        ' textboxes ...
        If intNum(1) = 0 Or intNum(2) = 0 Then
            intNum(1) = 0
            intNum(2) = 0
            txtNum1.Text = ""
            txtNum2.Text = ""
        End If
        If intNum(4) = 0 Or intNum(5) = 0 Then
            intNum(4) = 0
            intNum(5) = 0
            txtNum4.Text = ""
            txtNum5.Text = ""
        End If

        ' Convert mixed numbers to fractions. At this point we start to populate
        ' elements of the intSol array. After the following section of code is
        ' complete, the contents of the intSol array will be populated as follows:
        ' (0) (1) (2) (3) (4) (5) (6) (7) (8)
        ' --- --- --- --- --- --- --- --- ---
        '  43  8   14  3

        If intNum(1) = 0 And intNum(2) = 0 Then
            intSol(0) = intNum(0)
            intSol(1) = 1
        Else
            intSol(0) = (intNum(0) * intNum(2)) + intNum(1)
            intSol(1) = txtNum2.Text
        End If
        If intNum(4) = 0 And intNum(5) = 0 Then
            intSol(2) = intNum(3)
            intSol(3) = 1
        Else
            intSol(2) = (intNum(3) * intNum(5)) + intNum(4)
            intSol(3) = intNum(5)
        End If

        ' If we are doing addition (as we are in the case of the sample problem) or
        ' subtraction, we must find the common denominator and adjust elements in
        ' the solution array (intSol) accordingly. If we are doing division, switch
        ' the numerator and denominator of the second number so that it can be
        ' performed as multiplication. If we are doing multiplication, nothing
        ' special need be done at this point.

        If radAdd.Checked Or radSubtract.Checked Then

            ' For an addition or subtraction operation, find the common denominator
            ' and adjust elements in the solution array (intSol) accordingly ...

            ' In our sample problem, the common denominator will be 24 (8 * 3):
            intCommDenom = intSol(1) * intSol(3)

            ' As the next four lines execute, the contents of the intSol array
            ' will be populated as follows:
            '   (0) (1) (2) (3) (4) (5) (6) (7) (8)
            '   --- --- --- --- --- --- --- --- ---
            intSol(0) = intSol(0) * intSol(3)   '   129   8  14   3
            intSol(2) = intSol(2) * intSol(1)   '   129   8 112   3
            intSol(1) = intCommDenom            '   129  24 112   3
            intSol(3) = intCommDenom            '   129  24 112  24

        ElseIf radDivide.Checked Then

            ' Operation is division, so switch the numerator
            ' and denominator of the second number ...
            intTemp = intSol(2)
            intSol(2) = intSol(3)
            intSol(3) = intTemp
        End If

        ' The code in the Select Case structure below will populate elements (4) and
        ' (5) of the intSol solution array, which will contain the numerator and
        ' denominator of the "raw" (non-reduced) solution ...

        Select Case True

            Case radAdd.Checked
                ' For addition, add the numerators of the first and second numbers
                ' and place it over the common denominator.
                ' For our sample problem, after the two statements below execute,
                ' the contents of the intSol array will be populated as follows:
                ' (0) (1) (2) (3) (4) (5) (6) (7) (8)
                ' --- --- --- --- --- --- --- --- ---
                ' 129  24 112  24 241  24
                intSol(4) = intSol(0) + intSol(2)
                intSol(5) = intCommDenom

            Case radSubtract.Checked
                ' For subtraction, subtract the numerators of the first and second
                ' numbers and place it over the common denominator ...
                intSol(4) = intSol(0) - intSol(2)
                intSol(5) = intCommDenom

            Case Else
                ' For a mulitplication problem, or a division probelm that was
                ' converted to multiplication in a previous step, multiply the
                ' numerators and denominators of the first and second numbers
                ' by each other ...
                intSol(4) = intSol(0) * intSol(2)
                intSol(5) = intSol(1) * intSol(3)

        End Select

        ' Now, we must convert the "raw" result (numerator residing in intSol(4),
        ' denominator residing in intSol(5)) back to a mixed number. The three
        ' statements below will accomplish this, placing the integer portion of
        ' the mixed number in element (6) and the numerator and denominator of
        ' the mixed number in elements (7) and (8), respectively.
        '
        ' For our sample problem, after the two statements below execute,
        ' the contents of the intSol array will be populated as follows:
        ' (0) (1) (2) (3) (4) (5) (6) (7) (8)
        ' --- --- --- --- --- --- --- --- ---
        ' 129  24 112  24 241  24  10   1  24
        '
        intSol(6) = intSol(4) \ intSol(5)       ' Get the quotient
        intSol(7) = intSol(4) Mod intSol(5)     ' Get the remainder
        intSol(8) = intSol(5)                   ' Common denominator

        ' The following code serves to reduce (if necessary) the fractional
        ' protion of the final, mixed number result. In the case of the sample
        ' problem, the code will determine that reducing is not necessary in
        ' this particular case.

        If intSol(7) <> 0 Then
            ' Reduce the fractional portion of the final result by checking
            ' for a number that will divide evenly into both the numerator
            ' and the denominator. Do this by looping thru a set of values
            ' backwards, staring with the the value of the numerator, and working
            ' down toward a minimum of 2 ...
            For intReducer = intSol(7) To 2 Step -1
                If (intSol(7) Mod intReducer = 0) _
                And (intSol(8) Mod intReducer = 0) Then
                    ' We've found a number that divides evenly into both
                    ' the numerator and the denominator of the final answer,
                    ' so divide and get out ...
                    intSol(7) = intSol(7) \ intReducer
                    intSol(8) = intSol(8) \ intReducer
                    Exit For
                End If
            Next
        End If

        ' Display the solution (copy the values from the intSol array into
        ' corresponding elements of the lblSol "control array" on the form ...
        For intX = 0 To 8
            lblSol = DirectCast(GetControlByName(gbxSolution, "lblSol" & intX), Label)
            lblSol.Text = intSol(intX)
        Next

        ' Zero-suppress if necessary ...
        If intSol(6) = 0 And intSol(7) = 0 Then
            lblSol6.Text = "0"
            lblSol7.Text = ""
            lblSol8.Text = ""
        Else
            If intSol(6) = 0 Then
                lblSol6.Text = ""
            End If
            If intSol(7) = 0 Then
                lblSol7.Text = ""
                lblSol8.Text = ""
            End If
        End If

        ' Set the form such that the user can't enter in a problem while
        ' the solution is displayed. (They can either hit the Clear button
        ' or Exit.)

        SetFormState(False, Color.FromKnownColor(KnownColor.Control))

    End Sub


    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        '
        '   The Clear button prepares the form so that the user can enter a new
        '   problem by enabling the appropriate controls and clearing the txtNum
        '   and lblSol "control arrays".

        Dim intX As Integer

        SetFormState(True, Color.White)

        For intX = 0 To 5
            txtNum = DirectCast(GetControlByName(gbxProblem, "txtNum" & intX), TextBox)
            txtNum.Text = ""
        Next

        For intX = 0 To 8
            lblSol = DirectCast(GetControlByName(gbxSolution, "lblSol" & intX), Label)
            lblSol.Text = ""
        Next

        txtNum0.Focus()

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Function GetControlByName(ByVal pobjParent As Control, _
                                      ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

    Private Sub SetFormState(ByVal pblnEnabledValue As Boolean, _
                             ByVal plngBackColor As Color)

        ' This routine enables/disables controls on the form depending upon the
        ' state of the application: i.e., the user is either entering the data
        ' for the math problem, or is looking at the result.

        Dim intX As Integer
        Dim txtNum As TextBox

        gbxChooseOperation.Enabled = pblnEnabledValue
        radAdd.Enabled = pblnEnabledValue
        radSubtract.Enabled = pblnEnabledValue
        radMultiply.Enabled = pblnEnabledValue
        radDivide.Enabled = pblnEnabledValue

        gbxProblem.Enabled = pblnEnabledValue
        For intX = 0 To 5
            txtNum = DirectCast(GetControlByName(gbxProblem, "txtNum" & intX), TextBox)
            txtNum.BackColor = plngBackColor
        Next

        btnCalc.Enabled = pblnEnabledValue

    End Sub

    Private Function DataEntryError() As Boolean
        '
        ' This routine is called by the "calc" procedure to make sure we have
        ' have good numbers before trying to solve the math problem. If any
        ' one of a number of data entry errors is encountered, an error message
        ' is set, we decide what textbox should get the focus, we set the return
        ' value of this function to True, and get out. The calc procedure will test
        ' the return value of this function and if True, will display the error
        ' message and set the focus appropriately.

        If txtNum1.Text = "" And txtNum2.Text <> "" Then
            mstrErrorMsg = "The numerator of the first value is missing."
            mintNewFocus = 1
            Return True
        End If

        If txtNum2.Text = "" And txtNum1.Text <> "" Then
            mstrErrorMsg = "The denominator of the first value is missing."
            mintNewFocus = 2
            Return True
        End If

        If txtNum4.Text = "" And txtNum5.Text <> "" Then
            mstrErrorMsg = "The numerator of the second value is missing."
            mintNewFocus = 4
            Return True
        End If

        If txtNum5.Text = "" And txtNum4.Text <> "" Then
            mstrErrorMsg = "The denominator of the second value is missing."
            mintNewFocus = 5
            Return True
        End If

        If radDivide.Checked Then
            If Val(txtNum3.Text) = 0 And Val(txtNum4.Text) = 0 Then
                mstrErrorMsg = "Second value cannot be zero for division."
                mintNewFocus = 3
                Return True
            End If
        End If

        Return False

    End Function

End Class